#!/bin/bash
if [ $# -lt 2 ]
then
  echo "Usage: $0 <disk image> <size in MB>"
  exit
fi
echo "## Step 1: Generating diskimage $1 ..."
dd if=/dev/urandom of=$1 bs=1M count=$2
echo
echo "## Step 2: Mapping the diskimage to a disk device..."
losetup /dev/loop0 $1
echo
echo "## Step 3: Creating encrypted disk using the file $1. Please specify a disk password."
cryptsetup luksFormat -c aes -s 256 /dev/loop0 
echo
echo "## Step 4: Opening encrypted disk. Please enter disk password."
cryptsetup luksOpen /dev/loop0 cryptdisk.vol
echo 
echo "## Step 5: Creating FAT file system on the encrypted disk."
mkfs -t vfat /dev/mapper/cryptdisk.vol
echo 
echo "## Step 6: Finished. Cleaning up ..."
cryptsetup luksClose cryptdisk.vol
losetup -d /dev/loop0
